<%@page import="net.sf.basedb.util.ContextUtil.ContextResult"%>
<%-- $Id: index.jsp 6192 2012-10-31 12:34:19Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.Path"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.PluginExecutionRequest"
	import="net.sf.basedb.core.PluginResponse"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.Response"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.InteractivePlugin"
	import="net.sf.basedb.plugins.util.Parameters"
	import="net.sf.basedb.util.AutoDetectFileFormat"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ContextUtil"
	import="net.sf.basedb.util.ContextUtil.ContextResult"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.ArrayList"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final String root = request.getContextPath()+"/";
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final GuiContext.Type contextType = GuiContext.Type.valueOf(request.getParameter("context_type"));
final GuiContext context = new GuiContext(itemType, contextType, subContext);
final ItemContext cc = sc.getCurrentContext(itemType, subContext);

DbControl dc = null;;
String forward = null;
String message = null;
String redirect = null;
try
{
	if ("SelectPlugin".equals(cmd))
	{
		ItemQuery<PluginDefinition> pluginQuery = PluginDefinition.getQuery(context, null);
		pluginQuery.restrict(
			Restrictions.eq(
				Hql.property("mainType"),
				Expressions.integer(Plugin.MainType.IMPORT.getValue())
			)
		);
		pluginQuery.restrict(Restrictions.eq(Hql.property("disabled"), Expressions.parameter("isDisabled", false)));
		pluginQuery.order(Orders.asc(Hql.property("name")));
		pluginQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
		
		ItemQuery<PluginConfiguration> configQuery = PluginConfiguration.getQuery();
		configQuery.restrict(
				Restrictions.eq(
					Hql.property("pluginDefinition"),
					Expressions.parameter("plugin")
				)
			);
		configQuery.order(Orders.asc(Hql.property("name")));
		configQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
		
		dc = sc.newDbControl();
		Object currentItem = null;
		if (contextType == GuiContext.Type.ITEM)
		{
			currentItem = itemType.getById(dc, cc.getId());
		}
		List<ContextResult> contextResult = ContextUtil.checkContext(dc, pluginQuery, configQuery, context, currentItem);
		dc.close();

		boolean showWarnings = Values.getBoolean(sc.getUserClientSetting("plugins.showWarnings"), false);
		int totalPlugins = ContextUtil.countUsuablePlugins(contextResult);
		Set<String> contextMessages = ContextUtil.getContextMessages(contextResult, showWarnings, true);
		
		if (totalPlugins == 0)
		{
			String msg = "<b>No plugins can be used in this context, for the following reasons:</b><br><ul><li>";
			if (contextMessages.size() == 0)
			{
				msg += "Could not find any plugins that you have permission to use</ul>";
			}
			else
			{
				msg += Values.getString(contextMessages, "<li>", true) + "</ul>";
			}
			throw new WebException("popup", "No usable plugins found", msg);
		}
		sc.setSessionSetting("IMPORTERS", contextResult);
		sc.setSessionSetting("MESSAGES", contextMessages);
		forward = "select_plugin.jsp";
	}
	
	else if ("RunPlugin".equals(cmd))
	{
		int pluginDefinitionId = Values.getInt(request.getParameter("plugindefinition_id"));
		int pluginConfigurationId = Values.getInt(request.getParameter("pluginconfiguration_id"));
		
		if (pluginDefinitionId == -1 || pluginConfigurationId == -1)
		{
			// Auto-detect was selected
			forward = "select_file.jsp";
		}
		else
		{
			// Specific plugin and configuration was selected
			redirect = "../plugin/index.jsp?ID="+ID+
				"&cmd=NewJob&pluginconfiguration_id="+pluginConfigurationId+
				"&plugindefinition_id="+pluginDefinitionId+
				"&title="+request.getParameter("title")+
				"&job_name="+HTML.urlEncode(request.getParameter("job_name"))+
				"&job_description="+HTML.urlEncode(request.getParameter("job_description"))+
				"&item_type="+context.getItem().name()+
				"&subcontext="+subContext+
				"&context_type="+context.getType().name()+
				"&warnIfOpen=0";
		}
	}
	
	else if ("AutoDetect".equals(cmd))
	{
		int fileId = Values.getInt(request.getParameter("file_id"));
		String path = request.getParameter("path");
		String charset = request.getParameter("charset");
		dc = sc.newDbControl();
		File f = fileId != 0 ? File.getById(dc, fileId) : File.getByPath(dc, new Path(path, Path.Type.FILE), false);
		int maxRecent = Base.getMaxRecent(sc);
		cc.setRecent(f, maxRecent);

		int pluginDefinitionId = Values.getInt(request.getParameter("plugindefinition_id"));
		PluginDefinition plugin = null;
		if (pluginDefinitionId != -1)
		{
			plugin = PluginDefinition.getById(dc, pluginDefinitionId);
		}
		
		// Auto-detect file format
		Map<PluginDefinition, List<PluginConfiguration>> plugins = 
			AutoDetectFileFormat.findPlugins(dc, context, f, charset, plugin);

		cc.setObject("auto-detected-file", f);
		int matches = plugins.size();
		if (matches == 0)
		{
			forward = "no_fileformat.jsp?ID="+ID+
				"&file_id="+f.getId()+
				"&title="+request.getParameter("title")+
				"&job_name="+HTML.urlEncode(request.getParameter("job_name"))+
				"&job_description="+HTML.urlEncode(request.getParameter("job_description"))+
				"&item_type="+context.getItem().name()+
				"&subcontext="+subContext+
				"&context_type="+context.getType().name();
			//throw new WebException("popup", "Import failed", "Couldn't find any file format matching file {1}", f);
		}
		else
		{
			if (matches == 1)
			{
				plugin = plugins.entrySet().iterator().next().getKey();
				List<PluginConfiguration> configList = plugins.get(plugin);
				if (configList != null && configList.size() > 1)
				{
					// Multiple configurations matches
					matches = configList.size();
				}
				else
				{
					// 0 or 1 configuration matched
					PluginConfiguration pc = null;
					if (configList != null && configList.size() == 1)
					{
						pc = configList.get(0);
					}
					redirect = "../plugin/index.jsp?ID="+ID+
						"&cmd=NewJob" + 
						(pc == null ? "" : "&pluginconfiguration_id="+ pc.getId()) +
						"&plugindefinition_id="+plugin.getId()+
						"&title="+request.getParameter("title")+
						"&job_name="+HTML.urlEncode(request.getParameter("job_name"))+
						"&job_description="+HTML.urlEncode(request.getParameter("job_description"))+
						"&item_type="+context.getItem().name()+
						"&subcontext="+subContext+
						"&context_type="+context.getType().name()+
						"&parameter:" + Parameters.CHARSET_PARAMETER + "=" + HTML.urlEncode(charset) +
						"&warnIfOpen=0";
				}
			}
			if (matches > 1)
			{
				List<ContextResult> importers = new ArrayList<ContextResult>(matches);
				for (Map.Entry<PluginDefinition, List<PluginConfiguration>> entry : plugins.entrySet())
				{
					PluginDefinition pd = entry.getKey();
					List<PluginConfiguration> configList = entry.getValue();
					if (configList != null && configList.size() > 0)
					{
						for (PluginConfiguration pc : configList)
						{
							importers.add(new ContextResult(pd, pc, (String)null));
						}
					}
					else
					{
						importers.add(new ContextResult(pd, null, (String)null));
					}
				}
				sc.setSessionSetting("IMPORTERS", importers);
				forward = "select_plugin.jsp?noautodetect=1&message=Multiple+file+formats+found.+Please+select+one.";
			}
		}
	}

}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	sc.setSessionSetting("alert-message", message);
	pageContext.forward(forward);
}
else if (redirect != null)
{
	sc.setSessionSetting("alert-message", message);
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

